#pragma once

#include "defines.h"
#define SAMPLESPERBLOCK SAMPLESPERPACKET

typedef struct IMAADPCMBLOCK {
	short firstpcm;
	unsigned char firststate, maxvol;
	unsigned char data[SAMPLESPERBLOCK/2];
}IMAADPCMBLOCK;

class CImaAdpcm{
	static const int ISSTMAX = 88;
	static const short imaStepSizeTable[];
	static unsigned char imaStateAdjustTable[ISSTMAX][8];
	static bool m_bInited;

	int m_curpcm;
	int m_curstt;

public:
	CImaAdpcm();
	static void Init();
	static int Dec(short* out, int smpls, IMAADPCMBLOCK* in);
	void Reset(){ m_curpcm = 0; m_curstt = 0; }
	int Enc(IMAADPCMBLOCK* out, short* in, int smpls, int vol_db);
};