
#pragma once

typedef struct SESSIONINFO{
	SOCKADDR_IN sa;
	int sid;
	int alive;
}SESSIONINFO;

class CSessionManager {

protected:
	SESSIONINFO* m_session;
	int m_maxsessions;
	int m_maxalive;

public:

	CSessionManager(int MaxSessions = 16, int AliveTime = 5);
	~CSessionManager();

	int AddSession(const SOCKADDR_IN *sa, int sid);

	int DelSession(int id = 0);
	bool IsVaildSession(int id = 0);

	int GetSessionId(const SOCKADDR_IN* sa, int sid);

	int GetSessionSa(SOCKADDR_IN* sa, int id = 0);
	int GetSessionSid(int id = 0);
	int GetSessionTimer(int id = 0);

	int DecSessionTimer();
	int ResetSessionTimer(int id = 0);
};
