#pragma once

#ifndef SERVERONLY
#define APPTITLE TEXT("sky-")
#else
#define APPTITLE TEXT("sky- SERVER")
#endif

const int MAXCLIENTS = 16;
const int MAXUSERNAMELEN = 16;

const int SAMPLESPERPACKET = 500;
const int PCMBUFFERS = 16;
const int PCMBUFFERLEN = SAMPLESPERPACKET*2;

enum OuterMsg{
	WM_INITIALIZE = WM_APP+0x100,
	WM_CONNECT,

	SETMUTE,
	SETMUTE2,
};

enum InnerMsg{
	WM_SOCK = WM_APP+0x200,
	WM_SVSOCK,
	WM_GETHOST,
	WM_STARTSESSION,

	SRV_SECTIMER,
	CLI_SECTIMER,
	EXIT,
};

enum NetMsg{
	CSM_QACTIVATE = 0x10,
	SCM_RACTIVATE,
	SCM_NACTIVATE,

	CSM_QUNACTIVATE,
	SCM_NUNACTIVATE,

	CSM_QNULL,
	SCM_RNULL,

	CSM_DATA,
	SCM_DATA,

	CSM_QUSERLIST,
	SCM_RUSERLIST,
};

const int PKTHDRCODE = (('T')|('V'<<8)|('C'<<16)|('T'<<24));
const int MAXPKTSZ = 1024;


typedef struct PACKET{ // ʐMpPbgwb_
	struct PKTHDR{
		int pkthdrcode;
		int sid;
		int msg;
	}hdr;
	char data[MAXPKTSZ - sizeof(PKTHDR)];
} PACKET;

#define MSGTYPE(msg) ((msg)&0xFF)
#define MSGP1(msg) (((msg)>>8)&0xFF)
#define MSGP2(msg) (((msg)>>16)&0xFF)
#define MSGP3(msg) (((msg)>>24)&0xFF)
#define MAKEMSG(t,p1,p2,p3) (t|(p1<<8)|(p2<<16)|(p3<<24))

typedef struct SOCKETPARAM
{
	TCHAR UserName[MAXUSERNAMELEN];
	char RemoteHost[256];
	int ServerMode;
	int RemotePort;
	int LocalPort;
} SOCKETPARAM;

